﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Trolleybus.Entities
{
    /// <summary>
    /// Класс-сущность "Троллейбус"
    /// </summary>
    public class EntityTrolleybus : EntityBus
    {
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; private set; }
        /// <summary>
        /// Признак (опция) наличия "рогов"
        /// </summary>
        public bool Horns { get; private set; }
        /// <summary>
        /// Признак (опция) наличия отсека под электрические батареи
        /// </summary>
        public bool Batteries { get; private set; }
        /// <summary>
        /// Инициализация полей объекта-класса троллейбуса
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес троллейбуса</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="horns">Признак наличия "рогов"</param>
        /// <param name="batteries">Признак наличия отсека под электрические батареи</param>
        public EntityTrolleybus(int speed, double weight, Color bodyColor, Color additionalColor, bool horns, bool batteries) : base(speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            Horns = horns;
            Batteries = batteries;
        }
        public void ChangeAdditionalColor(Color color)
        {
            AdditionalColor = color;
        }
    }
}

