using Trolleybus.DrawingObjects;
using Trolleybus.MovementStrategy;

namespace Trolleybus
{
    /// <summary>
    ///     ""
    /// </summary>
    public partial class FormTrolleybus : Form
    {
        /// <summary>
        /// -   
        /// </summary>
        private DrawingBus? _drawingBus;
        /// <summary>
        ///  
        /// </summary>
        private AbstractStrategy? _abstractStrategy;
        /// <summary>
        ///  
        /// </summary>
        public DrawingBus? SelectedBus { get; private set; }

        public FormTrolleybus()
        {
            InitializeComponent();
            _abstractStrategy = null;
            SelectedBus = null;
        }
        /// <summary>
        ///   
        /// </summary>
        private void Draw()
        {
            if (_drawingBus == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingBus.DrawTransport(gr);
            pictureBoxTrolleybus.Image = bmp;
        }
        /// <summary>
        ///    " "
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreateTrolleybus_Click(object sender, EventArgs e)
        {
            Random random = new();
            Color color = Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256));

            //  
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256));

            //  
            ColorDialog dopDialog = new();
            if (dopDialog.ShowDialog() == DialogResult.OK)
            {
                dopColor = dopDialog.Color;
            }
            _drawingBus = new DrawingTrolleybus(random.Next(100, 300),
            random.Next(1000, 3000),
            color,
            dopColor,
            Convert.ToBoolean(random.Next(0, 2)),
            Convert.ToBoolean(random.Next(0, 2)),
            pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            //   
            _drawingBus.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///    " "
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreateBus_Click(object sender, EventArgs e)
        {
            Random random = new();
            // 
            Color color = Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _drawingBus = new DrawingBus(random.Next(100, 300),
            random.Next(1000, 3000),
            color,
            pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            _drawingBus.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();

        }
        /// <summary>
        ///    
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawingBus == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingBus.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingBus.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingBus.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingBus.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonStep_Click(object sender, EventArgs e)
        {
            if (_drawingBus == null)
            {
                return;
            }
            if (comboBoxStrategy.Enabled)
            {
                _abstractStrategy = comboBoxStrategy.SelectedIndex
                switch
                {
                    0 => new MoveToCenter(),
                    1 => new MoveToBorder(),
                    _ => null,
                };
                if (_abstractStrategy == null)
                {
                    return;
                }
                _abstractStrategy.SetData(new DrawingObjectBus(_drawingBus), pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
                comboBoxStrategy.Enabled = false;
            }
            if (_abstractStrategy == null)
            {
                return;
            }
            _abstractStrategy.MakeStep();
            Draw();
            if (_abstractStrategy.GetStatus() == Status.Finish)
            {
                comboBoxStrategy.Enabled = true;
                _abstractStrategy = null;
            }
        }

        /// <summary>
        ///  
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonSelectBus_Click(object sender, EventArgs e)
        {
            SelectedBus = _drawingBus;
            DialogResult = DialogResult.OK;
        }
    }
}